from twisted.internet import default; default.install()
#import debugot2
from twisted.internet import reactor
from random import choice
import icfp
import astar
import knapsack
import sys
host, port = sys.argv[1:3]

class RobotClient(icfp.ICFP2002ClientProtocol):
#class RobotClient(debugot2.Debugot):
    def ourFirstTime(self):
        self.addLog('OH YES MY FIRST TIME IS SO GOOD')
        self.path = None
        self.oldPositions = []
        self.stuckCount = 0
        self.bidWeight = 1
        self.bidWeightMult = 2.5

    def addLog(self, t): print t

    def endOfTurn(self):
    #def myEndOfTurn(self):
        myX, myY = self.getPosition()
        #if self.untriedPoints and (myX, myY) in self.untriedPoints:
        #    self.untriedPoints.remove((myX, myY))
        if self.path and self.path[0] == (myX, myY):
            self.path.pop(0)
        if len(self.knownRobots) == 1:
            self.bidWeight = 1 # floor it
            return self.moveToTarget(1) # bid this when we're the only robot
        closeRobots = self.closeRobots()

        if len(closeRobots) == 0:
            self.bidWeight = 1 # floor it
            return self.moveToTarget(1)
        for robot in closeRobots: # WATER STUFFS
            dx = robot.x - myX # i'm on 2, they're on 3, dx = 3 - 2 =1
            dy = robot.y - myY 
            # if abs(dx)+abs(dy) > 1: continue # can't water 'em XXX but then can water us
            #self.addLog(repr((myX, myY)))
            #self.addLog(str(robot))
            #self.addLog(repr((dx,dy)))
            # try the other side of me from them

            # 21~
            if abs(dx)+abs(dy) == 1 and self.map[myY - dy][myX - dx] == '~': # WATER SI BAD
                self.bidWeight = 1
                for x,y in icfp.ACR[(dx, dy)]:
                    if self.map[myY + y][myX + x] in '.@':
                        self.addLog('moving away from water (to (%s, %s))' % (myX + x, myY + y))
                        return self.moveToPoint((myX + x, myY + y), self.money // 500)
                # last resort
                self.addLog('trying to push robot to avoid water')
                return self.moveToPoint((robot.x, robot.y), self.money // 500) # bet a whole bunch, and hopefully push them away
            # other side of them (push 2 into water)

            # 12~
            elif abs(dx)+abs(dy) == 1 and self.map[robot.y + dy][robot.x + dx] == '~' \
                 and self.map[robot.y][robot.x] != '~': # WATER SI GOOD
                self.bidWeight = 1
                self.addLog('trying to push %s into water' % robot.id)
                return self.moveToPoint((robot.x, robot.y), self.money // 500)
            elif abs(dx)+abs(dy) > 1 and self.path:
                # we want to detect situations like this:
                # 2.
                # .1
                # ~.
                # where we want to move in between 2 and ~
                self.addLog('we might be in trouble, checking...')
                wx, wy = icfp.COORDS[self.getDirectionToPoint(self.path[0])]
                tx, ty = myX + wx, myY + wy
                #tx, ty = self.path[0][0] - myX, self.path[0][1] - myY
                #if abs(tx)+ == 2 or abs(ty) == 2: # not close, really
                #    return self.moveToTarget(1)
                items = [(tx+x,ty+y) for (x, y) in icfp.ACR[(wx,wy)]]
                k = []
                for x,y in items:
                    for r in self.knownRobots.values():
                        if r.x == x and r.y == y and 'r' not in k:
                            k.append('r')
                    if self.map[y][x] == '~':
                        k.append('w')
                if len(k) == 2: 
                    self.addLog('uh oh, water trickyness!')
                    self.redoPath()                 
                    return self.moveToPoint(self.path[0], 1)
        self.bidWeight = -self.bidWeight
        self.moveToTarget(max(1, self.money//2000)) # last resort

    def closeRobots(self):
        us = self.getPosition()
        dist = lambda x1, y1: abs(x1-us[0])+abs(y1-us[1])
        closeRobots = []
        for r in self.knownRobots.keys():
            robot = self.knownRobots[r]
            if dist(robot.x,robot.y) in (1, 2):
                closeRobots.append(robot)
        return closeRobots

    def calculateTarget(self):
        dist = lambda (x1, y1), (x2, y2): abs(x1-x2) + abs(y1-y2)
        us = self.getPosition()
        dist2 = lambda x: abs(x[0]-us[0])+abs(x[1]-us[1])
        if self.myPackages:
            packs = self.myPackages
            packs.sort(lambda x,y:cmp(dist(us, (x.x, x.y)), dist(us, (y.x, y.y))))
            self.addLog('using packages to find path')
            return (packs[0].x, packs[0].y)
        elif self.knownPackages:
            self.addLog('using self.knownPackages')
            keys = list(self.knownPackages.keys())
            for k in keys:
                if not self.knownPackages[k]:
                    keys.remove(k)
                    del self.knownPackages[k]
            if not keys:
                self.addLog('no more known packages!')
                return self.calculateTarget()
            # perhaps cache this?
            dist3cache = {}
            def dist3(x):
                if dist3cache.has_key(x):
                    return dist3cache[x]
                packs = self.knownPackages[x]
                packs.sort(lambda x,y:cmp(x.weight,y.weight))
                p = filter(lambda p:p.weight<=(self.weight-self.getCarryWeight()), packs)
                if not p:
                    dist3cache[x] = 99999999999L
                else:
                    p = p[-1]
                    dist3cache[x] = dist2(x) + dist(x, (p.x, p.y))
                return dist3cache[x]
            keys.sort(lambda x,y:cmp(dist3(x),dist3(y)))
            return keys[0]
        elif self.bases:
            self.addLog('heading for a base')
            self.bases.sort(lambda x,y:cmp(dist2(x),dist2(y)))
            return self.bases[0]           
        elif self.mightHavePackage:
            self.addLog('using self.mightHavePackage')
            self.mightHavePackage.sort(lambda x,y:cmp(dist2(x),dist2(y)))
            return self.mightHavePackage[0]
##        elif len(self.knownPackages) == 0 and self.points and not self.untriedPoints:
##            self.addLog('starting trial and error')
##            self.untriedPoints = []
##            for y in range(len(self.map)):
##                x=-1
##                while 1:
##                    x = self.map[y].find(icfp.PLAIN, x+1)
##                    if x == -1:
##                        break
##                    self.untriedPoints.append((x,y))
##            dist = lambda x: abs(x[0]-us[0])+abs(x[1]-us[1])
##            self.untriedPoints.sort(lambda x,y:cmp(dist(x),dist(y)))
##            target = self.untriedPoints.pop[0]
##        elif self.untriedPoints:
##            self.addLog('next trial and error')
##            target = self.untriedPoints.pop(0)
        else:
            robots = [r for r in self.knownRobots.values() if r.packages and r!=self.myRobot]
            robots.sort(lambda x,y:cmp(dist(us, (x.x, x.y)), dist(us, (y.x, y.y))))
            if robots:
                self.addLog('attacking robot %s' % robots[0].id)
                return robots[0]

    def calculateBestPath(self):
        us = self.getPosition()
        target = self.calculateTarget()
        if not target:
            self.addLog('uh no, no place to go')
            self.path = None
            return
        if type(target) not in (type((1,)), type([1])):
            # we're stalking a robot
            target = robot.x,robot.y
            cut = 3 # cut off for  the path, so we can find the robot
        else:
            cut = 0
        if self.map[target[1]][target[0]] == '~':
            self.addLog('why would you go in the water')
            return self.calculateBestPath()
        self.addLog('target: (%s, %s)' % target)
        us = us[1], us[0]
        target = target[1], target[0]
        path = astar.astar(us, target, self.map)[1:]
        self.path = [(x, y) for y,x in path]
        if cut:
            self.path = self.path[:cut]

    def moveToTarget(self, bid = 1):
        toDrop = []
        us = self.getPosition()
        for p in self.myPackages:
            if (p.x, p.y) == us:
                toDrop.append(p)
        if toDrop:
            self.addLog('dropping %s packages' % len(toDrop))
            return self.dropPackage(bid, [p.id for p in toDrop])
        if not self.knownPackages.has_key(us) and us in self.bases:
            self.addLog('removing base (%s, %s)' % us)
            self.bases.remove(us) # so we don't try it again           
        if self.knownPackages.has_key(us):
            if self.knownPackages[us] == [] and us in self.bases:
                self.addLog('removing base (%s, %s)' % us)
                self.bases.remove(us) # so we don't try it again
                del self.knownPackages[us]
            else:
                wg = self.pickUpSomeShit(bid)
                if wg:
                    self.addLog('picked up %s packages' % len(wg))
                    return
        if self.bidWeight > 1: self.bidWeight -= 1
        if not self.path:
            self.addLog('calculating path')
            self.calculateBestPath()
        if not self.path:
            self.addLog('EEK! picking  random move')
            return self.moveRobot(bid, choice('NESW'))
        #self.addLog('moving along the path')
        self.moveToPoint(self.path[0], bid)

    def moveToPoint(self, (x, y), bid):
        dist = lambda (x1, y1), (x2, y2): abs(x1-x2) + abs(y1-y2)
        us = self.getPosition()
        self.oldPositions.append(us)
        self.oldPositions = self.oldPositions[-15:] # keep track of last 10
        diff = (x - us[0], y - us[1])
        coords = [(dist(v,diff), k) for k,v in icfp.COORDS.items()]
        coords.sort(lambda x,y:cmp(x[0],y[0]))
        if coords[0][0] != 0:
            self.addLog("we are off the path of righteousness")
            self.addLog(repr(coords))
            self.addLog(repr((x,y)))
            self.addLog(repr(us))
            if self.oldPositions.count(us) > 3 or \
               abs(bid * self.bidWeight * self.bidWeightMult) > self.money / 100:
                self.addLog('creating new path')
                self.redoPath()
                # time to pathfind our way out
                return self.moveToTarget(bid)
##                for i in range(len(self.path)):
##                    if tempmap[self.path[i][1]][self.path[i][0]] in '.@': # good new path
##                        newtarget = (self.path[i][1],self.path[i][0])
##                        splice = astar.astar((us[1],us[0]), newtarget, tempmap)[1:]
##                        if splice:
##                            i += 1
##                            splice = [(x, y) for y,x in splice]
##                            self.addLog('adding a %s-long splice to our path' % len(splice))
##                            #icfp.showNumberedMap(tempmap)
##                            #print 'newtarget',(newtarget[1], newtarget[0])
##                            #print 'splice', splice
##                            #print 'replaces', self.path[:i]
##                            #print 'of', self.path
##                            self.path[:i] = splice
##                            #raw_input()
##                            self.bidWeight = 1
##                            return self.moveToPoint(self.path[0], bid)
##                        else:
##                            self.addLog('backing off, bidweight = -1')
##                            self.bidWeight = -1
            else:
                self.bidWeight *= self.bidWeightMult
                self.addLog('increasing bid weight to %s' % self.bidWeight)
        elif self.oldPositions.count(us) > 4:
            self.addLog("we're stuck!")
            self.addLog('backing off, bidweight = -1')
            self.bidWeight = -1
        elif self.oldPositions.count(us) > 3:
                self.bidWeight *= self.bidWeightMult
                self.addLog('increasing bid weight to %s' % self.bidWeight)          
        #    self.bidWeight *= self.bidWeightMult
        self.oldPosition = us
        bid *= self.bidWeight
        if int(bid) == 0:
            bid = bid < 0 and -1 or 1
        self.moveRobot(bid, coords[0][1])

    def redoPath(self):
        oldMap = self.map[:]
        for r in self.knownRobots.values():
            self.map[r.y] = self.map[r.y][:r.x] + '*' + self.map[r.y][r.x+1:]
        self.calculateBestPath()
        self.map = oldMap

    def pickUpSomeShit(self, bid):
        # function left as exercise for reader
        us = self.getPosition()
        dist = lambda x: abs(x.x-us[0])+abs(x.y-us[1])
        packs = self.knownPackages[us]
        packs.sort(lambda x,y:cmp(dist(y),dist(x)))
        weights  = [p.weight for p in packs]
        cancarry = self.weight - self.getCarryWeight()
        
        willget = knapsack.knapsack(weights, weights, cancarry)
        if willget:
            self.getPackage(bid, [packs[i].id for i in willget])
        return willget 

        
        #weights = map(dist, packs)

        #for p in packs:
        #    if p.weight <= cancarry:
        #        willget.append(p.id)
        #        cancarry -= p.weight

    def getDirectionToPoint(self, (x, y)):
        dist = lambda (x1, y1), (x2, y2): abs(x1-x2) + abs(y1-y2)
        us = self.getPosition()
        diff = (x - us[0], y - us[1])
        coords = [(dist(v,diff), k) for k,v in icfp.COORDS.items()]
        coords.sort(lambda x,y:cmp(x[0],y[0]))
        return coords[0][1]
            
    def gameEnded(self, message):
        print message
        
if __name__ == "__main__":
    #debugot2.main(RobotClient)
    reactor.clientTCP(host, int(port), RobotClient())
    reactor.run()
